var Immutable, Page, React, defaultInfo, jsonPersistent, rawPersistent, recorder, render, schema, updater;

React = require("react");

Immutable = require("immutable");

recorder = require("./recorder");

updater = require("./updater");

schema = require('./schema');

require("origami-ui");

require("../style/main.css");

defaultInfo = {
  initial: schema.store,
  updater: updater,
  inProduction: false
};

rawPersistent = localStorage.getItem("actions-recorder");

if (rawPersistent) {
  try {
    jsonPersistent = JSON.parse(rawPersistent);
    defaultInfo.initial = Immutable.fromJS(jsonPersistent.initial);
    defaultInfo.records = Immutable.fromJS(jsonPersistent.records);
    defaultInfo.pointer = jsonPersistent.pointer;
    defaultInfo.isTravelling = jsonPersistent.isTravelling;
  } catch (_error) {}
}

recorder.setup(defaultInfo);

if (module.hot) {
  module.hot.accept(['./updater', './schema'], function() {
    schema = require('./schema');
    updater = require('./updater');
    return recorder.hotSetup({
      initial: schema.store,
      updater: updater
    });
  });
}

window.onbeforeunload = function() {
  return recorder.request(function(store, core) {
    jsonPersistent = {
      records: core.records.toJS(),
      initial: core.initial.toJS(),
      pointer: core.pointer,
      isTravelling: core.isTravelling
    };
    rawPersistent = JSON.stringify(jsonPersistent);
    return localStorage.setItem("actions-recorder", rawPersistent);
  });
};

Page = React.createFactory(require("./app/page"));

render = render = function(store, core) {
  return React.render(Page({
    store: store,
    core: core
  }), document.body);
};

recorder.request(render);

recorder.subscribe(render);
